!c Description: 
!c   ϳإǥ deepconv/arare
!c
!c Current Code Owner: 
!c   sugiyama@gfd-dennou.org
!c
!c Copyright (C) SUGIYAMA Ko-ichiro, 2004, All rights reserved

program arare
  use gt4_history
  use gridset,  only: gridset_init, DimXMin, DimXMax, DimZMin, DimZMax, &
       &              RegXMin, RegXMax, RegZMin, RegZMax
  use fileset,  only: fileset_init
  use timeset,  only: timeset_init, NstepTShort, NstepTLong, &
       &              DelTShort, DelTLong
  use expname,  only: expname_init
  use linlib,   only: linlib_init
  use bcset,    only: bcset_init
  use basicset, only: basicset_init
  use distrbset,only: distrbset_init
  use arareprm, only: arareprm_init
  use if_display

  implicit none

  real(8), allocatable  :: fs_ForceX_B(:,:)
  real(8), allocatable  :: sf_ForceZ_B(:,:)
  
  real(8), allocatable  :: ss_Theta_C(:,:)
  real(8), allocatable  :: ss_Exner_C(:,:)
  real(8), allocatable  :: fs_VelX_C(:,:)
  real(8), allocatable  :: sf_VelZ_C(:,:)
  real(8), allocatable  :: ss_Theta_B(:,:)
  real(8), allocatable  :: ss_Exner_B(:,:)
  real(8), allocatable  :: fs_VelX_B(:,:)
  real(8), allocatable  :: sf_VelZ_B(:,:)
  real(8), allocatable  :: ss_Theta_A(:,:)
  real(8), allocatable  :: ss_Exner_A(:,:)
  real(8), allocatable  :: fs_VelX_A(:,:)
  real(8), allocatable  :: sf_VelZ_A(:,:)

  real(8)               :: Time

  type(gt_history)      :: ss_reg, fs_reg, sf_reg
  type(gt_history)      :: ss_dim, fs_dim, sf_dim
  

!!!
!!!
!!!
  !--- I/O ե̾ν
  call fileset_init
  
  !--- ʻν
  call gridset_init
  
  !--- ʬν
  call timeset_init
  
  !--- ¸̾ν
  call expname_init
  
  !--- ׻ɤ߹
  call arareprm_init

  !--- 
  call bcset_init

  !--- ܾͤ
  call basicset_init

  !--- ͤ
  call distrbset_init
  
  !--- ׻饤֥ν. 
  !--- ϥ顼 z η׻ΰ礭
  call linlib_init(RegZMax - RegZMin)
  
  !--- ϥե
  call ArareOpenRegFile
  call ArareOpenDimFile

!!!
!!! CFL Υå
!!!
  call cflchk


!!!
!!!ѿν
!!!  
  !--- γ, 
  call ArareAlloc


!!!
!!!ʬ
!!!
  !--- ֤ե
  Time = 0.0d0
  call ArareOutputRegFile
  call ArareOutputDimFile
  
  !--- ե
  call ArareOutputRegFile
  call ArareOutputDimFile

  !--- ե
  call ArareOutputRegFile
  call ArareOutputDimFile
     

  !--- ϥեΥ
  call ArareCloseRegFile
  call ArareCloseDimFile


contains


!!!
!!!γ, 
!!!
  subroutine ArareAlloc
    use distrbset, only: fs_VelXDistrb, sf_VelZDistrb, &
         &               ss_ExnerDistrb, ss_ThetaDistrb

    allocate(fs_VelX_A(DimXMin:DimXMax, DimZMin:DimZMax), &
         & sf_VelZ_A(DimXMin:DimXMax, DimZMin:DimZMax), &
         & ss_Exner_A(DimXMin:DimXMax, DimZMin:DimZMax), &
         & ss_Theta_A(DimXMin:DimXMax, DimZMin:DimZMax), &
         & fs_VelX_B(DimXMin:DimXMax, DimZMin:DimZMax), &
         & sf_VelZ_B(DimXMin:DimXMax, DimZMin:DimZMax), &
         & ss_Exner_B(DimXMin:DimXMax, DimZMin:DimZMax), &
         & ss_Theta_B(DimXMin:DimXMax, DimZMin:DimZMax), &
         & fs_VelX_C(DimXMin:DimXMax, DimZMin:DimZMax), &
         & sf_VelZ_C(DimXMin:DimXMax, DimZMin:DimZMax), &
         & ss_Exner_C(DimXMin:DimXMax, DimZMin:DimZMax), &
         & ss_Theta_C(DimXMin:DimXMax, DimZMin:DimZMax), &
         & fs_ForceX_B(DimXMin:DimXMax, DimZMin:DimZMax), &
         & sf_ForceZ_B(DimXMin:DimXMax, DimZMin:DimZMax) )

    fs_VelX_A = 0.0d0
    fs_VelX_B = 0.0d0
    fs_VelX_C = 0.0d0

    sf_VelZ_A = 0.0d0
    sf_VelZ_B = 0.0d0
    sf_VelZ_C = 0.0d0

    ss_Exner_A = 0.0d0
    ss_Exner_B = 0.0d0
    ss_Exner_C = 0.0d0
    
    ss_Theta_A = 0.0d0
    ss_Theta_B = 0.0d0
    ss_Theta_C = 0.0d0

    fs_ForceX_B = 0.0d0
    sf_ForceZ_B = 0.0d0


    Time = 0.0d0

    !®پν
    fs_VelX_A  = fs_VelXDistrb
    fs_VelX_B  = fs_VelXDistrb
    sf_VelZ_A = sf_VelZDistrb
    sf_VelZ_B = sf_VelZDistrb

    !̵Ϥν
    ss_Exner_A = ss_ExnerDistrb
    ss_Exner_B = ss_ExnerDistrb

    !̤ν
    ss_Theta_A = ss_ThetaDistrb
    ss_Theta_B = ss_ThetaDistrb

  end subroutine ArareAlloc


!!!
!!!ϥե. ׻ΰΤ
!!! 
  subroutine ArareOpenRegFile
    use gridset, only: RegXMin, RegXMax, RegZMin, RegZMax, &
         & NX, NZ, f_X, f_Z, s_X, s_Z
    use expname, only: exptitle, expsrc, expinst
    use fileset, only: fs_RegFile, sf_RegFile, ss_RegFile
    
    ! ҥȥ꡼
    call HistoryCreate(                                    &
         & file = fs_RegFile,                               &
         & title = exptitle,                               &
         & source = expsrc,                                &
         & institution = expinst,                          &
         & dims=(/'x','z','t'/),                           &
         & dimsizes=(/NX+1, NZ, 0/),                       &
         & longnames=(/'X-coordinate',                     &
         &             'Z-coordinate',                     &
         &             'Time        '/),                   &
         & units=(/'m','m','s'/), origin=0.0,              &
         & interval=0.0, &
         & history = fs_reg)
    
    ! ѿ
    call HistoryPut('x', f_X(RegXMin: RegXMax), fs_reg)
    call HistoryPut('z', s_Z(RegXMin+1: RegXMax), fs_reg)
    
    ! ҥȥ꡼
    call HistoryCreate(                                    &
         & file = sf_RegFile,                               &
         & title = exptitle,                               &
         & source = expsrc,                                &
         & institution = expinst,                          &
         & dims=(/'x','z','t'/),                           &
         & dimsizes=(/NX, NZ+1, 0/),                       &
         & longnames=(/'X-coordinate',                     & 
         &             'Z-coordinate',                     &
         &             'Time        '/),                   &
         & units=(/'m','m','s'/),                          &
         & origin=0.0,                                     &
         & interval=0.0,                                   &
         & history = sf_reg)
    
    ! ѿ
    call HistoryPut('x', s_X(RegXMin+1: RegXMax), sf_reg)
    call HistoryPut('z', f_Z(RegXMin: RegXMax), sf_reg)

    ! ҥȥ꡼
    call HistoryCreate(                                  &
         & file = ss_RegFile,                            &         
         & title = exptitle,                             &
         & source = expsrc,                              &
         & institution = expinst,                        &
         & dims=(/'x','z','t'/),                         &
         & dimsizes=(/NX, NZ, 0/),                       &
         & longnames=(/'X-coordinate',                   &
         &             'Z-coordinate',                   &
         &             'Time        '/),                 &
         & units=(/'m','m','s'/), origin=0.0,            &
         & interval=0.0,                                 &
         & history = ss_reg)
    
    ! ѿ
    call HistoryPut('x', s_X(RegXMin+1: RegXMax), ss_reg)
    call HistoryPut('z', s_Z(RegXMin+1: RegXMax), ss_reg)
    
    ! ̵
    call HistoryAddVariable(                             &
         & varname='Exner', dims=(/'x','z','t'/),        &
         & longname='nondimensional pressure', units='1',&
         & xtype='double',                               & 
         & history = ss_reg)    
    ! 
    call HistoryAddVariable(                            &
         & varname='Theta', dims=(/'x','z','t'/),      &
         & longname='virtual potential temperature',    &
         & units='K', xtype='double',                 & 
         & history = ss_reg)    
    ! ®
    call HistoryAddVariable(                            &
         & varname='VelX', dims=(/'x','z','t'/),             &
         & longname='zonal velocity',         &
         & units='m/s', xtype='double',                & 
         & history = fs_reg)        
    ! ®
    call HistoryAddVariable(                            &
         & varname='VelZ', dims=(/'x','z','t'/),             &
         & longname='vertical velocity',         &
         & units='m/s', xtype='double',                & 
         & history = sf_reg)    
    
  end subroutine ArareOpenRegFile


!!!
!!!ե. Ĺ֥ƥåפǽ. ׻ΰΤ
!!!
  subroutine ArareOutputRegFile
    use gridset, only: RegXMin, RegXMax, RegZMin, RegZMax

    call HistoryPut('t', Time, ss_reg)
    call HistoryPut('t', Time, fs_reg)
    call HistoryPut('t', Time, sf_reg)

    call HistoryPut('Exner', &
         & ss_Exner_A(RegXMin+1:RegXMax, RegZMin+1:RegZMax), ss_reg)
    call HistoryPut('Theta', &
         & ss_Theta_A(RegXMin+1:RegXMax, RegZMin+1:RegZMax), ss_reg)
    call HistoryPut('VelX', &
         & fs_VelX_A(RegXMin:RegXMax, RegZMin+1:RegZMax), fs_reg)
    call HistoryPut('VelZ', &
         & sf_VelZ_A(RegXMin+1:RegXMax, RegZMin:RegZMax), sf_reg)
  end subroutine ArareOutputRegFile


!!!
!!!ϥեΥ. ׻ΰΤ
!!!  
  subroutine ArareCloseRegFile
    call HistoryClose( ss_reg )
    call HistoryClose( fs_reg )
    call HistoryClose( sf_reg )
  end subroutine ArareCloseRegFile


!!!
!!!ϥե. ΰ
!!!
  subroutine ArareOpenDimFile
    use gridset, only: f_X, f_Z, s_X, s_Z
    use expname, only: exptitle, expsrc, expinst
    use fileset, only: fs_DimFile, sf_DimFile, ss_DimFile
    
    integer::   N
    
    N = size(f_X, 1)

    ! ҥȥ꡼
    call HistoryCreate(                                    &
         & file = fs_DimFile,                              &
         & title = exptitle,                               &
         & source = expsrc,                                &
         & institution = expinst,                          &
         & dims=(/'x','z','t'/),                           &
         & dimsizes=(/N, N, 0/),                           &
         & longnames=(/'X-coordinate',                     &
         &             'Z-coordinate',                     &
         &             'Time        '/),                   &
         & units=(/'m','m','s'/), origin=0.0,              &
         & interval=0.0, &
         & history = fs_dim)
    
    ! ѿ
    call HistoryPut('x', f_X, fs_dim)
    call HistoryPut('z', s_Z, fs_dim)
    
    ! ҥȥ꡼
    call HistoryCreate(                                    &
         & file = sf_DimFile,                              &
         & title = exptitle,                               &
         & source = expsrc,                                &
         & institution = expinst,                          &
         & dims=(/'x','z','t'/),                           &
         & dimsizes=(/N, N, 0/),                           &
         & longnames=(/'X-coordinate',                     & 
         &             'Z-coordinate',                     &
         &             'Time        '/),                   &
         & units=(/'m','m','s'/),                          &
         & origin=0.0,                                     &
         & interval=0.0,                                   &
         & history = sf_dim)
    
    ! ѿ
    call HistoryPut('x', s_X, sf_dim)
    call HistoryPut('z', f_Z, sf_dim)

    ! ҥȥ꡼
    call HistoryCreate(                                  &
         & file = ss_DimFile,                            &
         & title = exptitle,                             &
         & source = expsrc,                              &
         & institution = expinst,                        &
         & dims=(/'x','z','t'/),                         &
         & dimsizes=(/N, N, 0/),                         &
         & longnames=(/'X-coordinate',                   &
         &             'Z-coordinate',                   &
         &             'Time        '/),                 &
         & units=(/'m','m','s'/), origin=0.0,            &
         & interval=0.0,                                 &
         & history = ss_dim)
    
    ! ѿ
    call HistoryPut('x', s_X, ss_dim)
    call HistoryPut('z', s_Z, ss_dim)
    
    ! ̵
    call HistoryAddVariable(                             &
         & varname='Exner', dims=(/'x','z','t'/),        &
         & longname='nondimensional pressure', units='1',&
         & xtype='double',                               & 
         & history = ss_dim)    
    ! 
    call HistoryAddVariable(                            &
         & varname='Theta', dims=(/'x','z','t'/),      &
         & longname='virtual potential temperature',    &
         & units='K', xtype='double',                   & 
         & history = ss_dim)    
    ! ®
    call HistoryAddVariable(                            &
         & varname='VelX', dims=(/'x','z','t'/),        &
         & longname='zonal velocity',                   &
         & units='m/s', xtype='double',                 & 
         & history = fs_dim)        
    ! ®
    call HistoryAddVariable(                            &
         & varname='VelZ', dims=(/'x','z','t'/),        &
         & longname='vertical velocity',                &
         & units='m/s', xtype='double',                 & 
         & history = sf_dim)    
  end subroutine ArareOpenDimFile


!!!
!!!ե. Ĺ֥ƥåפͤ. ΰ
!!!
  subroutine ArareOutputDimFile
    call HistoryPut('t', Time, ss_dim)
    call HistoryPut('t', Time, fs_dim)
    call HistoryPut('t', Time, sf_dim)

    call HistoryPut('Exner', ss_Exner_A, ss_dim)
    call HistoryPut('Theta', ss_Theta_A, ss_dim)
    call HistoryPut('VelX',  fs_VelX_A, fs_dim)
    call HistoryPut('VelZ',  sf_VelZ_A, sf_dim)
  end subroutine ArareOutputDimFile


!!!
!!!ϥեΥ. ΰ
!!!  
  subroutine ArareCloseDimFile
    call HistoryClose( ss_dim )
    call HistoryClose( fs_dim )
    call HistoryClose( sf_dim )
  end subroutine ArareCloseDimFile


end program arare
